<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>oska: Threading</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="files.html">File&nbsp;List</a></div>
<h1>Threading</h1><table border=0 cellpadding=0 cellspacing=0>
<tr><td></td></tr>
<tr><td colspan=2><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>typedef implementation_defined&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__thread.html#ga0">os_thread_t</a></td></tr>

<tr><td colspan=2><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__thread.html#ga1">os_thread_create</a> (<a class="el" href="group__thread.html#ga0">os_thread_t</a> *thread, const char *name, void(*func)(void *), void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__thread.html#ga2">os_thread_stop</a> (<a class="el" href="group__thread.html#ga0">os_thread_t</a> *thread, os_semaphore_t *sem)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__thread.html#ga3">os_thread_should_stop</a> (<a class="el" href="group__thread.html#ga0">os_thread_t</a> *thread)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__thread.html#ga4">os_try_suspend_thread</a> (<a class="el" href="group__thread.html#ga0">os_thread_t</a> *thread)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Threading support depends on the semaphore API provided by &lt;oska/semaphore.h&gt; (see <a class="el" href="group__semaphore.html">Semaphores</a>). <hr><h2>Typedef Documentation</h2>
<a class="anchor" name="ga0" doxytag="thread.h::os_thread_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef implementation_defined <a class="el" href="group__thread.html#ga0">os_thread_t</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Implementation defined thread object.     </td>
  </tr>
</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="ga1" doxytag="thread.h::os_thread_create" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int os_thread_create </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__thread.html#ga0">os_thread_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>thread</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>const char *&nbsp;</td>
          <td class="mdname" nowrap> <em>name</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void(*&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>)(void *), </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Create and start a thread.<p>
The thread function should call <a class="el" href="group__thread.html#ga3">os_thread_should_stop()</a> and return when it returns true.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>thread</em>&nbsp;</td><td>pointer to OS-specific thread data. </td></tr>
    <tr><td valign=top><em>name</em>&nbsp;</td><td>thread name. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>thread entry-point function. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument for func.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; negative error code otherwise. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga3" doxytag="thread.h::os_thread_should_stop" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int os_thread_should_stop </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__thread.html#ga0">os_thread_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>thread</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return true if the thread should stop (as signalled by a call to <a class="el" href="group__thread.html#ga2">os_thread_stop()</a>).<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>thread</em>&nbsp;</td><td>the thread to check.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>true iff the thread should stop. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga2" doxytag="thread.h::os_thread_stop" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void os_thread_stop </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__thread.html#ga0">os_thread_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>thread</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>os_semaphore_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>sem</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Stop a thread and wait for it to exit.<p>
If <em>sem</em> is non-NULL it will be posted to awaken the thread. The thread will also be awakened if it's asleep (in a <a class="el" href="group__time.html#ga1">os_sleep_ms()</a> call for example).<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>thread</em>&nbsp;</td><td>the thread to stop. </td></tr>
    <tr><td valign=top><em>sem</em>&nbsp;</td><td>a semaphore to post to awaken the thread, may be NULL.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve otherwise. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga4" doxytag="thread.h::os_try_suspend_thread" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void os_try_suspend_thread </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__thread.html#ga0">os_thread_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>thread</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Try to suspend a thread.<p>
This specifies a point where it is safe for a thread to be suspended.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>thread</em>&nbsp;</td><td>pointer to OS-specific thread data. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:35 2008 for oska by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
